/* (c) Peter Mueller, 2008 - All rights reserved. Reproduction, modification,
 * use or disclosure to third parties without express
 * authority is forbidden. Generator running in demo mode!
 * Please purchase a license if you want to use this software in projects.
 */

/* This file is generated from complex.cdd - do not edit manually*/
/* Generated on: Tue Apr 29 20:37:15 CEST 2008 / version 1.01 */


#include "mydefs.h"
#include "complex.h"
#include "complex_ext.h"
#include <stdio.h>

extern unsigned char msg;

void complex(COMPLEX_INSTANCEDATA_T *instanceVar){

	COMPLEX_EV_CONSUMED_FLAG_T evConsumed = 0U;

	/*execute entry code of default state once to init machine */
	if(instanceVar->s1Entry==1U){
		instanceVar->s1Entry=0U;
		printf("S12Entry\n");
	}
	/* action code */
	printf("Outer test action\n");

	switch(instanceVar->stateVar){

			case S1:

				switch(instanceVar->stateVarS1){

					/*
					 * Code for transitions starting from innter states
					 */
					case S11:
						/* action code */
						printf("S11 Action\n");

						if((msg==(COMPLEX_EVENT_T)e1)){
							/*Selftransition from S11 to S11*/
							evConsumed = 1U;

							/*OnExit code of state S11 */
							printf("S11Exit\n");

							/*Action code for transition */
							printf("e1Act\n");

							/*onEntry code of state S11 */
							printf("S11Entry\n");
						}else if((msg==(COMPLEX_EVENT_T)e12)){
							/*Transition from S11 to S12*/
							evConsumed = 1U;

							/*OnExit code of state S11 */
							printf("S11Exit\n");

							/*Action code for transition */
							printf("e12\n");

							/*onEntry code of state S12 */
							printf("S12Entry\n");
							complexChangeToStateS1(instanceVar,S12);
						}
						else
						{
							/* Intentionally left blank */
						}
					break;

					case S12:
						/* action code */
						printf("S12 Action\n");

						if((msg==(COMPLEX_EVENT_T)e13)){
							evConsumed = 1U;

							/*onExit code of state S12 */
							printf("S12Exit\n");
							/*Set inner statevar of source to default state */
							complexChangeToStateS1(instanceVar,S12);

							/*Action code for transition */
							printf("e13Act\n");

							/* onEntry code of state S22*/
							printf("S22Entry\n");
							/*Set outer statevar */
							complexChangeToState(instanceVar,S2);
							
							/* Set inner statevar of target */
							complexChangeToStateS2(instanceVar,S22);
						}else if((msg==(COMPLEX_EVENT_T)e14)){
							/*Transition from S12 to S11*/
							evConsumed = 1U;

							/*OnExit code of state S12 */
							printf("S12Exit\n");

							/*Action code for transition */
							printf("e14\n");

							/*onEntry code of state S11 */
							printf("S11Entry\n");
							complexChangeToStateS1(instanceVar,S11);
						}
						else
						{
							/* Intentionally left blank */
						}
					break;

					default:
						/*Intentionally left blank*/
					break;
				}
				if(evConsumed == 0U){
				/*Event not consumed by inner states, handover to parent */
				if((msg==(COMPLEX_EVENT_T)e2)){
					/*Check what the inner state is and call */
					/*the correspoing onExit code (if available)*/
					if(instanceVar->stateVarS1==S11){
						printf("S11Exit\n");
					}else if(instanceVar->stateVarS1==S12){
						printf("S12Exit\n");
					}
					/*Set inner statevar of source*/
					complexChangeToStateS1(instanceVar,S12);

					/*Action code for transition*/
					printf("e2Act\n");

					/*S2 has no onEntry code */

					/* onEntry code of state S22 */
					printf("S22Entry\n");

					/* Set outer statevar */
					complexChangeToState(instanceVar,S2);

					/*Set inner statevar of target*/
					complexChangeToStateS2(instanceVar,S22);
				}else if((msg==(COMPLEX_EVENT_T)e4)){
					/*Check what the inner state is and call     */
					/*the correspoing onExit code (if available) */
					if(instanceVar->stateVarS1==S11){
						printf("S11Exit\n");
					}else if(instanceVar->stateVarS1==S12){
						printf("S12Exit\n");
					}
					/*Set inner statevar of source to default state */
					complexChangeToStateS1(instanceVar,S12);

					/*Action code for transition*/
					printf("e4Act\n");

					/*onEntry code of state S12*/
					printf("S12Entry\n");
					/*Adaption of inner statevar not necessary because */
					/*it was already set above when leaving the state  */

					/*Outer statevar must not be adjusted due */
					/*to start and target are the same states */
				}else if((msg==(COMPLEX_EVENT_T)e5)){
					/*Check what the inner state is and call */
					/*the correspoing onExit code (if available)*/
					if(instanceVar->stateVarS1==S11){
						printf("S11Exit\n");
					}else if(instanceVar->stateVarS1==S12){
						printf("S12Exit\n");
					}
					/*Set inner statevar of source*/
					complexChangeToStateS1(instanceVar,S11);

					/*Action code for transition*/
					printf("e5Act\n");

					/*S1 has no onEntry code */

					/* onEntry code of state S11 */
					printf("S11Entry\n");

					/*Optimizations due to transition to same superstate: */
					/*a) inner statevar already set above */
					/*b) outer statevar needs no adaption */

				}else if((msg==(COMPLEX_EVENT_T)e7)){
					/*Check what the inner state is and call     */
					/*the correspoing onExit code (if available) */
					if(instanceVar->stateVarS1==S11){
						printf("S11Exit\n");
					}else if(instanceVar->stateVarS1==S12){
						printf("S12Exit\n");
					}
					/*Set inner statevar of source to default state */
					complexChangeToStateS1(instanceVar,S12);

					/*Action code for transition*/
					printf("e7Act\n");

					/* onEntry code of state S3*/
					printf("S3Entry\n");

					/*Set outer statevar*/
					complexChangeToState(instanceVar,S3);
				}else if((msg==(COMPLEX_EVENT_T)e1)){
					/*Check what the inner state is and call     */
					/*the correspoing onExit code (if available) */
					if(instanceVar->stateVarS1==S11){
						printf("S11Exit\n");
					}else if(instanceVar->stateVarS1==S12){
						printf("S12Exit\n");
					}
					/*Set inner statevar of source to default state */
					complexChangeToStateS1(instanceVar,S12);

					/*Action code for transition*/
					printf("e1Act\n");

					/*Find out which child state to enter */
					/*as target state is a history state  */
					if(instanceVar->stateVarS2==S21){
						/*onEntry code of state S21*/
						printf("S21Entry\n");
					}
					else if(instanceVar->stateVarS2==S22){
						/*onEntry code of state S22*/
						printf("S22Entry\n");
					}

					/*Set outer statevar*/
					complexChangeToState(instanceVar,S2);
				}
				else
				{
					/* Intentionally left blank */
				}
				}
			break;

			case S2:

				switch(instanceVar->stateVarS2){

					/*
					 * Code for transitions starting from innter states
					 */
					case S21:
						/* action code */
						printf("S21 Action\n");

						if((msg==(COMPLEX_EVENT_T)e16)){
							/*Transition from S21 to S22*/
							evConsumed = 1U;

							/*OnExit code of state S21 */
							printf("S21Exit\n");

							/*Action code for transition */
							printf("e16\n");

							/*onEntry code of state S22 */
							printf("S22Entry\n");
							complexChangeToStateS2(instanceVar,S22);
						}
						else
						{
							/* Intentionally left blank */
						}
					break;

					case S22:
						/* action code */
						printf("S22 Action\n");

						if((msg==(COMPLEX_EVENT_T)e20)){
							/*Innertransition from S22 to S22*/
							evConsumed = 1U;

							/*Action code for transition */
							printf("e20Act\n");
						}else if((msg==(COMPLEX_EVENT_T)e15)){
							/*Transition from S22 to S21*/
							evConsumed = 1U;

							/*OnExit code of state S22 */
							printf("S22Exit\n");

							/*Action code for transition */
							printf("e15\n");

							/*onEntry code of state S21 */
							printf("S21Entry\n");
							complexChangeToStateS2(instanceVar,S21);
						}
						else
						{
							/* Intentionally left blank */
						}
					break;

					default:
						/*Intentionally left blank*/
					break;
				}
				if(evConsumed == 0U){
				/*Event not consumed by inner states, handover to parent */
				if((msg==(COMPLEX_EVENT_T)e6)){
					/*Check what the inner state is and call     */
					/*the correspoing onExit code (if available) */
					if(instanceVar->stateVarS2==S21){
						printf("S21Exit\n");
					}else if(instanceVar->stateVarS2==S22){
						printf("S22Exit\n");
					}
					/*inner statevar must not be adjusted due to history state */

					/*Action code for transition*/
					printf("e6Act\n");

					/*onEntry code of state S12*/
					printf("S12Entry\n");
					/*Set inner statevar to default state */
					complexChangeToStateS1(instanceVar,S12);

					/*Set outer statevar*/
					complexChangeToState(instanceVar,S1);
				}
				else
				{
					/* Intentionally left blank */
				}
				}
			break;

			case S3:
				/* action code */
				printf("S3 Action\n");

				if((msg==(COMPLEX_EVENT_T)e21)){
					/* Innertransition from S3 to S3 (without substates) */

					/*Action code for transition */
					printf("e21Act\n");
				}else if((msg==(COMPLEX_EVENT_T)e8)){
					/* Selftransition from S3 to S3 (without substates) */

					/*OnExit code of state S3 */
					printf("S3Exit\n");

					/*Action code for transition */
					printf("e8Act\n");

					/*onEntry code of state S3 */
					printf("S3Entry\n");
				}else if((msg==(COMPLEX_EVENT_T)e9)){
					/*Transition from S3 to S4 (both without substates)*/

					/*OnExit code of state S3 */
					printf("S3Exit\n");

					/*Action code for transition */
					printf("e9Act\n");

					/*onEntry code of state S4 */
					printf("S4Entry\n");
					/*Set outer statevar */
					complexChangeToState(instanceVar,S4);
				}
				else
				{
					/* Intentionally left blank */
				}
			break;

			case S4:
				/* action code */
				printf("S4 Action\n");

				if((msg==(COMPLEX_EVENT_T)e10)){
					/*Transition from S4 to S1 (which has substates)*/

					/*OnExit code of state S4 */
					printf("S4Exit\n");

					/*Action code for transition */
					printf("e10Act\n");

					/*onEntry code of state S12*/
					printf("S12Entry\n");
					/*Set inner statevar to default state */
					complexChangeToStateS1(instanceVar,S12);

					/*Set outer statevar */
					complexChangeToState(instanceVar,S1);
				}else if((msg==(COMPLEX_EVENT_T)e11)){

					/*onExit code of state S4*/
					printf("S4Exit\n");

					/*Action code for transition*/
					printf("e11Act\n");

					/*S1 has no onEntry code*/

					/*onEntry code of state S12*/
					printf("S12Entry\n");
					/*Set outer statevar */
					complexChangeToState(instanceVar,S1);

					/*Set inner statevar of target*/
					complexChangeToStateS1(instanceVar,S12);
				}
				else
				{
					/* Intentionally left blank */
				}
			break;

			default:
				/*Intentionally left blank*/
			break;
	}
}
